import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "className", "href", "inverse", "iconInline", "iconPlacement"];
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import classNames from 'classnames';
import ddsSettings from '../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings';
import Link from '../../internal/vendor/carbon-components-react/components/Link/Link';
import PropTypes from 'prop-types';
import React from 'react';
import settings from 'carbon-components/es/globals/js/settings';
var stablePrefix = ddsSettings.stablePrefix;
var prefix = settings.prefix;

/**
 * LinkWithIcon component.
 */
var LinkWithIcon = function LinkWithIcon(_ref) {
  var children = _ref.children,
    customClassName = _ref.className,
    href = _ref.href,
    inverse = _ref.inverse,
    iconInline = _ref.iconInline,
    iconPlacement = _ref.iconPlacement,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("".concat(prefix, "--link-with-icon__container"), customClassName, _defineProperty({}, "".concat(prefix, "--link-with-icon__container__inverse"), inverse)),
    "data-autoid": "".concat(stablePrefix, "--link-with-icon")
  }, /*#__PURE__*/React.createElement(Link, _extends({
    size: "lg",
    href: href,
    className: classNames("".concat(prefix, "--link-with-icon"), _defineProperty(_defineProperty({}, "".concat(prefix, "--link-with-icon__icon-left"), iconPlacement === 'left'), "".concat(prefix, "--link-with-icon--inline-icon"), iconInline && iconPlacement === 'right'))
  }, props), children));
};
LinkWithIcon.propTypes = {
  /**
   * Array containing Link text and icon elements.
   */
  children: PropTypes.arrayOf(PropTypes.node),
  /**
   * Url of link.
   */
  href: PropTypes.string,
  /**
   * Positions the icon inline with text when `true`
   */
  iconInline: PropTypes.bool,
  /**
   * Icon placement.
   */
  iconPlacement: PropTypes.oneOf(['left', 'right']),
  /**
   * Toggles inverse theming
   */
  inverse: PropTypes.bool,
  /**
   * custom classname
   */
  className: PropTypes.string
};
LinkWithIcon.defaultProps = {
  children: [],
  href: '',
  iconInline: true,
  iconPlacement: 'right'
};
export default LinkWithIcon;