import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["href", "title", "children"];
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import ArrowRight16 from '@carbon/icons-react/es/arrow--right/16';
import LinkWithIcon from '../../LinkWithIcon/LinkWithIcon';
import PropTypes from 'prop-types';
import React from 'react';
import settings from 'carbon-components/es/globals/js/settings';
var prefix = settings.prefix;

/**
 * Category Group of the MegaMenu
 * contains the category headline and sublinks
 */
var CategoryGroup = function CategoryGroup(_ref) {
  var href = _ref.href,
    title = _ref.title,
    children = _ref.children,
    rest = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__category-group")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__category-group-shield")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__category-group-content")
  }, href ? /*#__PURE__*/React.createElement(LinkWithIcon, {
    href: href,
    className: "".concat(prefix, "--masthead__megamenu__category-headline"),
    "data-autoid": "".concat(rest.autoid, "-list").concat(rest.index)
  }, /*#__PURE__*/React.createElement("span", null, title), /*#__PURE__*/React.createElement(ArrowRight16, null)) : /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__category-headline"),
    "data-autoid": "".concat(rest.autoid, "-list").concat(rest.index)
  }, /*#__PURE__*/React.createElement("p", null, title)), children)));
};
CategoryGroup.propTypes = {
  /**
   * Category Groups sublinks
   */
  children: PropTypes.node,
  /**
   * url of the Category Group headline
   */
  href: PropTypes.string,
  /**
   * Category Group headline title
   */
  title: PropTypes.string.isRequired
};
export default CategoryGroup;