import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children"];
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import ddsSettings from '../../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings';
import PropTypes from 'prop-types';
import React from 'react';
import settings from 'carbon-components/es/globals/js/settings';
var stablePrefix = ddsSettings.stablePrefix;
var prefix = settings.prefix;

/**
 * MegaMenu panel
 */
var NavigationGroup = /*#__PURE__*/React.forwardRef(function NavigationGroup(props, ref) {
  var children = props.children,
    rest = _objectWithoutProperties(props, _excluded);
  return /*#__PURE__*/React.createElement("section", _extends({
    className: "".concat(prefix, "--masthead__megamenu"),
    "data-autoid": "".concat(stablePrefix, "--masthead__megamenu"),
    ref: ref
  }, rest), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__container")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--masthead__megamenu__container--row")
  }, children)));
});
NavigationGroup.propTypes = {
  /**
   * children elements
   */
  children: PropTypes.node
};
export default NavigationGroup;