import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
/**
 * Copyright IBM Corp. 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

// eslint-disable-next-line sort-imports
import { checkPreferencesv3, loadContent } from './services';
import React, { useCallback, useEffect, useRef, useState } from 'react';
import BPIDLegalText from './BPIDLegalText';
import Checkbox from '../../internal/vendor/carbon-components-react/components/Checkbox';
// eslint-disable-next-line sort-imports
import countrySettings from './country-settings';
import { DDS_NOTICE_CHOICE } from '../../internal/FeatureFlags.js';
import ddsSettings from '../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings';
import featureFlag from '../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/featureflag/featureflag';
import { getMappedValue } from './utils';
import PropTypes from 'prop-types';
import settings from 'carbon-components/es/globals/js/settings';
import SkeletonText from '../../internal/vendor/carbon-components-react/components/SkeletonText';
import worldWideContent from './world-wide-content';
var stablePrefix = ddsSettings.stablePrefix;
var prefix = settings.prefix;
var emailRegExp = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
export function NoticeChoice(_ref) {
  var locale = _ref.locale,
    country = _ref.country,
    questionChoices = _ref.questionChoices,
    email = _ref.email,
    onChange = _ref.onChange,
    termsConditionLink = _ref.termsConditionLink,
    classNames = _ref.classNames,
    defaultValues = _ref.defaultValues,
    enableAllOptIn = _ref.enableAllOptIn,
    bpidLegalText = _ref.bpidLegalText,
    state = _ref.state;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    loaded = _useState2[0],
    setLoaded = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    changed = _useState4[0],
    setChanged = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    preText = _useState6[0],
    setPreText = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    postText = _useState8[0],
    setPostText = _useState8[1];
  var _useState9 = useState(),
    _useState10 = _slicedToArray(_useState9, 2),
    checkboxes = _useState10[0],
    setCheckboxes = _useState10[1];
  var _useState11 = useState(),
    _useState12 = _slicedToArray(_useState11, 2),
    ncData = _useState12[0],
    setNcData = _useState12[1];
  var _useState13 = useState(_objectSpread(_objectSpread({}, worldWideContent.OptInContent), {}, {
      cclc: "".concat(worldWideContent.cc_name, "-").concat(worldWideContent.cc_lang)
    })),
    _useState14 = _slicedToArray(_useState13, 2),
    optInContent = _useState14[0],
    setOptInContent = _useState14[1];
  var _useState15 = useState(false),
    _useState16 = _slicedToArray(_useState15, 2),
    prefChange = _useState16[0],
    setPrefChange = _useState16[1];
  var _useState17 = useState(''),
    _useState18 = _slicedToArray(_useState17, 2),
    fetchedPref = _useState18[0],
    setFetchedPref = _useState18[1];
  var _useState19 = useState({
      EMAIL: false,
      PHONE: false,
      POSTAL: false,
      NC_HIDDEN_EMAIL: worldWideContent.cc_default_status,
      NC_HIDDEN_PHONE: worldWideContent.cc_default_status,
      NC_HIDDEN_POSTAL: worldWideContent.cc_default_status
    }),
    _useState20 = _slicedToArray(_useState19, 2),
    values = _useState20[0],
    setValues = _useState20[1];
  var defaultPreText = useRef('');
  var getOptionByQuestion = useCallback(function (question, OptInContentValue) {
    var OptInContent = OptInContentValue;
    if (!OptInContent) {
      OptInContent = ncData.OptInContent;
    }
    var option;
    switch (question) {
      case 'EMAIL':
        {
          option = OptInContent.fourQuestionApp[0];
          break;
        }
      case 'PHONE':
        {
          option = OptInContent.fourQuestionApp[1];
          break;
        }
      case 'POSTAL':
        {
          option = OptInContent.fourQuestionApp[2];
          break;
        }
      default:
        {
          option = OptInContent.fourQuestionApp[0];
          break;
        }
    }
    return option;
  }, [ncData]);

  /**
   * If the `enableAllOptIn` variable is false, then for each key in the `checkboxes` object, set the
   * value of the `newValues` object to the value defined in the notice choice content, or if the
   * `defaultValues` object has a property with the same name as the key, then set the value of the
   * `newValues` object to the value of the `defaultValues` object's property
   */
  var setDefaultSelections = useCallback(function () {
    if (!enableAllOptIn && checkboxes) {
      var newValues = _objectSpread({}, values);
      Object.keys(checkboxes).forEach(function (key) {
        var option = getOptionByQuestion(key, optInContent);
        newValues[key] = !!(option.checked === 'true' || option.checked === true);
        if (Object.prototype.hasOwnProperty.call(defaultValues, key)) {
          newValues[key] = defaultValues[key];
        }
        var fieldName = "NC_CHECK_".concat(key);
        var hiddenFieldName = "NC_HIDDEN_".concat(key);
        onChange(fieldName, newValues[key]);
        onChange(hiddenFieldName, newValues[key] ? 'OPT_IN' : null);
      });
      if (JSON.stringify(values) !== JSON.stringify(newValues)) {
        setValues(newValues);
      }
    }
  }, [values, checkboxes, enableAllOptIn, defaultValues, onChange, getOptionByQuestion, optInContent]);
  /**
   * The function is called when the user changes the country. It checks if the country is English,
   * and if so, it sets the pre-text to the default pre-text
   */
  var countryChangeAction = useCallback(function () {
    var splitValue = locale.split('-', 2);
    var ncData = getNcContentFromWindow();
    if (splitValue[1] === 'en') {
      var _preText = defaultPreText.current;
      if (ncData.OtherPreferences.englishNoticeText !== '') {
        _preText = ncData.OtherPreferences.englishNoticeText;
      }
      setPreText(_preText);
    }
    /**
     * @description if the user already interacted with the checkboxes,
     * skip country default selection.
     */
    if (!changed && !fetchedPref) {
      /**
       * @description
       * change checkbox checked option based on new country.
       */
      setDefaultSelections();
    }
  }, [locale, setDefaultSelections, changed, fetchedPref]);
  useEffect(function () {
    if (optInContent.cclc) {
      countryChangeAction();
    }
  }, [optInContent.cclc, countryChangeAction]);
  var loadECMData = useCallback(function () {
    var cc = 'zz';
    var lc = 'en';
    var ccLcObject = getMappedValue(locale);
    cc = ccLcObject.cc;
    lc = ccLcObject.lc;
    resetToWorldWideContent();
    loadContent(cc, lc, function (data) {
      // Sent content language
      setNcData(data);
    }), function (e) {
      console.error('Unable to load ncContent', e);
    };
  }, [locale]);
  useEffect(function () {
    loadECMData();
  }, [locale, loadECMData]);
  useEffect(function () {
    var cc = 'zz';
    var lc = 'en';
    if (country && countrySettings[country.toLocaleLowerCase()]) {
      cc = country.toLocaleLowerCase();
      lc = countrySettings[country.toLocaleLowerCase()].lang;
    }
    resetToWorldWideContent();
    loadContent(cc, lc, function (data) {
      /**
       * @description Do not change content language.
       * Change the checkbox according to the country rule.
       */
      setOptInContent(_objectSpread(_objectSpread({}, data.OptInContent), {}, {
        cclc: "".concat(worldWideContent.cc_name, "-").concat(worldWideContent.cc_lang)
      }));
    }), function (e) {
      console.error('Unable to load ncContent', e);
    };
  }, [country]);

  /**
   * It checks if the email address is Opt-in (Supressed) the preferences, and if it is, it sets
   * the checkbox to false
   */
  var emailChanged = useCallback(function (email) {
    if (prefChange === false) {
      checkPreferencesv3(email).then(function (response) {
        if (response === 'S' && JSON.stringify(values) !== JSON.stringify(_objectSpread(_objectSpread({}, values), {}, {
          EMAIL: false
        }))) {
          setFetchedPref(email);
          setValues(_objectSpread(_objectSpread({}, values), {}, {
            EMAIL: false
          }));
          onChange('NC_CHECK_EMAIL', false);
          onChange('NC_HIDDEN_EMAIL', null);
        }
      });
    }
  },
  // eslint-disable-next-line react-hooks/exhaustive-deps
  []);
  var getPostText = useCallback(function () {
    var OptInContent = ncData.OptInContent;
    var OtherPreferences = ncData.OtherPreferences;
    var postText = OptInContent.postText;
    var tcHtml = '';
    if (termsConditionLink) {
      var originalValue = OtherPreferences.trailPrivacyText;
      var matchedValue = originalValue.match(/<tc>.*<\/tc>/g);
      if (matchedValue) {
        var anrTagHtml = matchedValue[0].replace(/<tc>|<\/tc>/g, '');
        var link = "<a href='".concat(termsConditionLink, "' target='_blank' class='ibm-tooltip' >").concat(anrTagHtml, "</a>");
        var reg = new RegExp('<tc>' + anrTagHtml + '</tc>', 'g');
        tcHtml = "<p>I accept the product  <a href='".concat(termsConditionLink, "' target='_blank' class='ibm-tooltip' >").concat(anrTagHtml, "</a> of this registration form.</p>");
        postText = originalValue.replace(reg, link);
      }
    }
    // replace default privacy link
    try {
      var _getMappedValue = getMappedValue(locale),
        _cc = _getMappedValue.cc,
        _lc = _getMappedValue.lc;
      postText = postText.replaceAll('www.ibm.com/privacy/zz/en/', "www.ibm.com/".concat(_cc, "-").concat(_lc, "/privacy"));
    } catch (e) {
      console.log('unable to replace privacy link locale code.');
    }
    var ccLcObject = getMappedValue(locale);
    var cc = ccLcObject.cc;
    var lc = ccLcObject.lc;
    var ccpa = country === 'US' && (state === 'CA' || state === '');
    if (country === 'CN' && lc === 'en') {
      return "<p class=\"nc-gdpr-info\">I agree and acknowledge that IBM may share my personal information with IBM affiliates and third parties globally.\n         I understand that I can withdraw my marketing consent at any time by submitting an <a href=\"https://www.ibm.com/account/reg/".concat(cc, "-").concat(lc, "/signup?formid=urx-42537\" target=\"_blank\">opt-out request</a>,\n         and also may unsubscribe from receiving marketing emails by clicking the unsubscribe link in each email. More information in IBM\u2019s use and processing of personal information can be found in the <a href=\"https://www.ibm.com/privacy\" target=\"_blank\">IBM Privacy Statement</a>.\n         <p class=\"nc-gdpr-ack\">By ticking the above boxes and submitting this form, I have read and understand the above notice and  IBM Privacy Statement.</p>").concat(tcHtml);
    } else if (lc === 'en' && ccpa) {
      return "<p class=\"nc-gdpr-info\">You can withdraw your marketing consent at any time by submitting an <a href='https://www.ibm.com/account/reg/us-en/signup?formid=urx-42537' target='_blank'>opt-out request</a>. Also you may unsubscribe from receiving marketing emails by clicking the unsubscribe link in each email.</p>\n      <p class=\"nc-gdpr-ack\"> More information on our processing can be found in the <a href='https://www.ibm.com/privacy' target='_blank'>IBM Privacy Statement.</a>\n      California residents, review <a href=\"https://www.ibm.com/privacy/ccpa\" target=\"_blank\">our notice and your privacy choices</a>.\n      <br> By submitting this form, I acknowledge that I have read and understand the IBM Privacy Statement.</p>".concat(tcHtml);
    }
    return postText;
  }, [ncData, country, state, termsConditionLink, locale]);

  // Email changed
  useEffect(function () {
    if (email) {
      if (email !== fetchedPref) {
        // Handle throttle using debounce approach.
        if (emailRegExp.test(email)) {
          setTimeout(function () {
            emailChanged(email);
          }, 1000);
        }
      }
    } else {
      if (fetchedPref) {
        setFetchedPref('');
      }
    }
  }, [email, emailChanged, fetchedPref]);
  useEffect(function () {
    if (values && !loaded) {
      setLoaded(true);
    }
  }, [values, loaded]);
  useEffect(function () {
    if (ncData) {
      var buildCheckboxes = function buildCheckboxes(OptInContent) {
        var fieldElements = {};
        var fieldCollections = {
          EMAIL: {
            id: 'EMAIL',
            labelText: getOptionByQuestion('EMAIL', OptInContent).optionTextPost
          },
          PHONE: {
            id: 'PHONE',
            labelText: getOptionByQuestion('PHONE', OptInContent).optionTextPost
          },
          POSTAL: {
            id: 'POSTAL',
            labelText: getOptionByQuestion('POSTAL', OptInContent).optionTextPost
          }
        };
        // by email
        if (questionChoices.indexOf(1) > -1) {
          fieldElements.EMAIL = fieldCollections.EMAIL;
        }
        // by Phone
        if (questionChoices.indexOf(2) > -1) {
          fieldElements.PHONE = fieldCollections.PHONE;
        }
        // by Postal mail
        if (questionChoices.indexOf(3) > -1) {
          fieldElements.POSTAL = fieldCollections.POSTAL;
        }
        return fieldElements;
      };
      try {
        var OptInContent = ncData.OptInContent;
        var newCheckboxes = buildCheckboxes(OptInContent);
        setPreText(OptInContent.preText);
        setPostText(getPostText());
        defaultPreText.current = OptInContent.preText;
        setCheckboxes(newCheckboxes);
      } catch (e) {
        console.log('Unable to build checkboxes', e);
      }
    }
  }, [ncData, termsConditionLink, questionChoices, getOptionByQuestion, getPostText]);

  // end of useEffect
  var resetToWorldWideContent = function resetToWorldWideContent() {
    try {
      window.NoticeChoice = window.NoticeChoice || {};
      window.NoticeChoice.Content = worldWideContent;
    } catch (e) {
      console.log('unable to set worldWideContent', e);
    }
  };
  var getNcContentFromWindow = function getNcContentFromWindow() {
    var Content;
    try {
      Content = window.NoticeChoice.Content;
    } catch (e) {
      Content = worldWideContent;
    }
    return Content;
  };
  var checkBoxChange = function checkBoxChange(checked, id) {
    var newValues = _objectSpread({}, values);
    newValues[id] = !!checked;
    setValues(newValues);
    setChanged(true);
    setPrefChange(true);
    var fieldName = "NC_CHECK_".concat(id);
    var hiddenFieldName = "NC_HIDDEN_".concat(id);
    onChange(fieldName, checked);
    onChange(hiddenFieldName, checked ? 'PERMISSION' : 'SUPPRESSION');
  };
  var customPostText = postText;
  var ncHeading = useCallback(function () {
    return /*#__PURE__*/React.createElement("p", {
      id: "ncHeading",
      className: "".concat(prefix, "--nc__pre-text"),
      dangerouslySetInnerHTML: {
        __html: preText
      }
    });
  }, [preText]);
  return featureFlag(DDS_NOTICE_CHOICE, /*#__PURE__*/React.createElement("section", {
    "data-autoid": "".concat(stablePrefix, "--nc"),
    className: "".concat(prefix, "--nc ").concat(classNames)
  }, loaded ? /*#__PURE__*/React.createElement("div", null, ncHeading(), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--checkbox-group")
  }, checkboxes && Object.keys(checkboxes).length > 0 && Object.keys(checkboxes).map(function (key) {
    var checked = values[key];
    return /*#__PURE__*/React.createElement("span", {
      key: key
    }, /*#__PURE__*/React.createElement(Checkbox, _extends({}, checkboxes[key], {
      checked: checked,
      onChange: checkBoxChange,
      key: key,
      className: "".concat(prefix, "--nc__checkbox-").concat(key)
    })));
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefix, "--nc__post-text"),
    dangerouslySetInnerHTML: {
      __html: customPostText
    }
  })) : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(SkeletonText, null), /*#__PURE__*/React.createElement(SkeletonText, null), /*#__PURE__*/React.createElement(SkeletonText, null), /*#__PURE__*/React.createElement(SkeletonText, null)), bpidLegalText && /*#__PURE__*/React.createElement(BPIDLegalText, {
    bpidLegalText: bpidLegalText
  })));
}
NoticeChoice.propTypes = {
  /**
   * locale in a format of counrycode-languagecode example: us-en.
   */
  locale: PropTypes.string.isRequired,
  /**
   * Country value.
   */
  country: PropTypes.string.isRequired,
  /**
   * questionChoices of the widget. Choose from:
   *
   * | Name    | Description                                                                 |
   * | ------- | --------------------------------------------------------------------------- |
   * | `[1]`          | Only email field exist on your form.  |
   * | `[1, 2]`       | form has email and phone number.      |
   * | `[1, 2, 3]`    | email phone and postal code.          |
   */
  questionChoices: PropTypes.array,
  /**
   * Email value.
   * Important! Only change email value prop when the user ends typing the email.
   */
  email: PropTypes.string,
  /**
   * callback function when a value changes
   */
  onChange: PropTypes.func.isRequired,
  /**
   * Custom terms & condition link if applicable. Otherwise default value is https://www.ibm.com/legal
   */
  termsConditionLink: PropTypes.string,
  /**
   * custom class name of the main
   */
  classNames: PropTypes.string,
  /**
   * default values of the chekboxes:
   */
  defaultValues: PropTypes.shape({
    EMAIL: PropTypes.bool,
    PHONE: PropTypes.bool,
    POSTAL: PropTypes.bool
  }),
  /**
   * enableAllOptIn, only true in some specific cases.
   * if true, then by default all checkexes will be unchecked inrespective of country law.
   */
  enableAllOptIn: PropTypes.bool,
  /**
   * bpidLegalText, applicable when the form data may shared with business partner.
   * bpid should preset in the host page query string.
   * Sample english copy:
   * If you register with IBM for an IBM offering promoted by a business partner site,
   * we may inform them that you registered with us.
   */
  bpidLegalText: PropTypes.string,
  /**
   * state, Users residing state
   * Optional. required to apply state specific privacy satement
   */
  state: PropTypes.string
};
NoticeChoice.defaultProps = {
  email: '',
  locale: 'en-us',
  onChange: function onChange() {},
  questionChoices: [1],
  classNames: '',
  defaultValues: {},
  enableAllOptIn: false,
  country: 'us',
  state: ''
};
export default NoticeChoice;