/**
 * Copyright IBM Corp. 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import axios from 'axios';
export function checkPreferencesv3(emailAddress) {
  var endpoint = "https://www.ibm.com/account/apis/v2.0/pws/V3.0/lookup";
  return new Promise(function (resolve, reject) {
    if (emailAddress && emailAddress.indexOf('*****') > -1) {
      resolve('N');
    } else {
      axios.get(endpoint, {
        params: {
          emailAddress: emailAddress
        }
      }).then(function (response) {
        resolve(response.data ? response.data.email : 'N');
      }).catch(function (error) {
        console.error(error); // eslint-disable-line no-console
        reject('N');
      });
    }
  });
}
export function loadContent(cc, lc) {
  var onSuccess = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
  var onError = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function () {};
  var script = document.createElement('script');
  script.async = false;
  script.charset = 'utf-8';
  script.src = "https://www.ibm.com/common/translations/notice/".concat(cc, "/").concat(lc, "/ncContent_v18.js"); // URL for the third-party library being loaded.
  document.body.appendChild(script);
  script.onload = function () {
    try {
      if (onSuccess) onSuccess(window.NoticeChoice.Content);
    } catch (e) {
      if (onError) onError(e);
    }
  };
  script.onerror = function () {
    if (onError) onError();
  };
}