import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/* eslint-disable jsx-a11y/anchor-is-valid */
import { PropTypes } from 'prop-types';
import React from 'react';
export var headings = ['Forward thinkers', 'Innovation and transformation', 'Client success stories', 'Iconic moments in IBM history', 'Trust and responsibility', 'Connect with IBM'];

// eslint-disable-next-line max-len
export var LOREM = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras molestie condimentum consectetur. Nulla tristique lacinia elit, at elementum dui gravida non. Mauris et nisl semper, elementum quam non, lacinia purus. Vivamus aliquam vitae sapien volutpat efficitur. Curabitur sagittis neque facilisis magna posuere consectetur. Praesent fermentum sodales facilisis. Mauris a efficitur sem. Aliquam vehicula sapien libero, a viverra felis scelerisque vel. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Donec fringilla dui tellus, a pretium diam vehicula et. Etiam non vulputate augue. Morbi laoreet diam dapibus sapien pellentesque tristique. Morbi id nibh metus. Integer non scelerisque nisl.";
var generateCopySections = function generateCopySections(n) {
  return _toConsumableArray(Array(n)).map(function () {
    return /*#__PURE__*/React.createElement("p", null, LOREM);
  });
};
var DataContent = function DataContent(_ref) {
  var items = _ref.items;
  return /*#__PURE__*/React.createElement("div", {
    className: "dds-react-demo--table-of-contents"
  }, items === null || items === void 0 ? void 0 : items.map(function (_ref2, i) {
    var heading = _ref2.heading,
      copy = _ref2.copy;
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("a", {
      "data-title": heading,
      name: i
    }, /*#__PURE__*/React.createElement("h3", null, heading)), copy ? copy.split('\n').map(function (section) {
      return /*#__PURE__*/React.createElement("p", null, section);
    }) : generateCopySections(3));
  }));
};
DataContent.propTypes = {
  /**
   * Array of table of contents items
   */
  items: PropTypes.array
};
export default DataContent;