import _defineProperty from "@babel/runtime/helpers/defineProperty";
/* istanbul ignore file */

/**
 * Copyright IBM Corp. 2016, 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

import settings from 'carbon-components/es/globals/js/settings';
import cx from 'classnames';
import PropTypes from 'prop-types';
import React from 'react';
var prefix = settings.prefix;
var SideNavIcon = function SideNavIcon(_ref) {
  var children = _ref.children,
    customClassName = _ref.className,
    small = _ref.small;
  var className = cx(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefix, "--side-nav__icon"), true), "".concat(prefix, "--side-nav__icon--small"), small), customClassName, !!customClassName));
  return /*#__PURE__*/React.createElement("div", {
    className: className
  }, children);
};
SideNavIcon.propTypes = {
  /**
   * Provide an optional class to be applied to the containing node
   */
  className: PropTypes.string,
  /**
   * Provide a single icon as the child to `SideNavIcon` to render in the
   * container
   */
  children: PropTypes.node.isRequired,
  /**
   * Specify whether the icon should be placed in a smaller bounding box
   */
  small: PropTypes.bool.isRequired
};
SideNavIcon.defaultProps = {
  small: false
};
export default SideNavIcon;