"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _FeatureFlags = require("../../internal/FeatureFlags");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _settings = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

var prefix = _settings.default.prefix;
var AudioPlayerCaptionText = function AudioPlayerCaptionText(_ref) {
  var captions = _ref.captions,
    audioTime = _ref.audioTime;
  var captionText = (captions || []).filter(function (caption) {
    return audioTime >= caption.start && audioTime <= caption.end;
  }).map(function (caption) {
    return caption.content;
  }).join('<br />');
  return captions && /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--audio-player__captions")
  }, /*#__PURE__*/_react.default.createElement("p", {
    className: "".concat(prefix, "--audio-player__captions-text"),
    dangerouslySetInnerHTML: {
      __html: captionText
    }
  }));
};
AudioPlayerCaptionText.propTypes = {
  /**
   * An array containing all the captions for the current
   *  selected language.
   * Each entry of this array is an object containing:
   *  start -> Number - The first second of the audio where
   *          the caption should be displayed
   *  end -> Number - The last second of the audio where
   *          the caption should be displayed
   *  content -> String - The html content of the caption
   */
  captions: _propTypes.default.array.isRequired,
  /**
   * The state getter for the current audio time (in seconds)
   */
  audioTime: _propTypes.default.number.isRequired
};
AudioPlayerCaptionText.defaultProps = {
  captions: [],
  audioTime: 0
};
var _default = exports.default = !_FeatureFlags.DDS_AUDIO_PLAYER ? undefined : AudioPlayerCaptionText;