"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _FeatureFlags = require("../../internal/FeatureFlags");
var _KalturaPlayer = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-services/services/KalturaPlayer/KalturaPlayer"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _settings = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
/**
 * Copyright IBM Corp. 2016, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

var prefix = _settings.default.prefix;
var AudioPlayerThumbnail = function AudioPlayerThumbnail(_ref) {
  var audioId = _ref.audioId;
  var inputRef = (0, _react.useRef)(null);
  var thumbnailUrl = _KalturaPlayer.default.getThumbnailUrl({
    mediaId: audioId,
    width: '48',
    height: '48'
  });
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--audio-player__thumbnail-container"),
    ref: inputRef
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--audio-player__thumbnail"),
    style: {
      backgroundImage: "url('".concat(thumbnailUrl, "')")
    }
  })));
};
AudioPlayerThumbnail.propTypes = {
  /**
   * The Media ID from Kaltura media platform.
   */
  audioId: _propTypes.default.string.isRequired
};
AudioPlayerThumbnail.defaultProps = {};
var _default = exports.default = !_FeatureFlags.DDS_AUDIO_PLAYER ? undefined : AudioPlayerThumbnail;