"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireWildcard(require("react"));
var _CardLink = require("../CardLink");
var _CTALogic = _interopRequireDefault(require("./CTALogic"));
var _KalturaPlayer = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-services/services/KalturaPlayer/KalturaPlayer"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _settings = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
var _excluded = ["type", "openLightBox", "renderLightBox", "videoTitle", "disableImage"],
  _excluded2 = ["style"];
/**
 * Copyright IBM Corp. 2016, 2024
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var PlayIcon = function PlayIcon(props) {
  return /*#__PURE__*/_react.default.createElement("svg", props, /*#__PURE__*/_react.default.createElement("title", null, "Group 3"), /*#__PURE__*/_react.default.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/_react.default.createElement("circle", {
    fillOpacity: ".9",
    fill: "#525252",
    cx: "32",
    cy: "32",
    r: "32"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M26.556 43.111a1 1 0 0 1-1-1v-22a1 1 0 0 1 1.5-.87l19 11a1 1 0 0 1 0 1.74l-19 11a1 1 0 0 1-.5.13z",
    fill: "#F3F3F3",
    fillRule: "nonzero"
  })));
};
PlayIcon.defaultProps = {
  width: "64",
  height: "64",
  viewBox: "0 0 64 64",
  xmlns: "http://www.w3.org/2000/svg"
};
var prefix = _settings.default.prefix;

/**
 * Card subcomponent for CTA.
 */
var CardCTA = function CardCTA(_ref) {
  var type = _ref.type,
    openLightBox = _ref.openLightBox,
    renderLightBox = _ref.renderLightBox,
    videoTitle = _ref.videoTitle,
    disableImage = _ref.disableImage,
    otherProps = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  // eslint-disable-next-line no-unused-vars
  var style = otherProps.style,
    cardProps = (0, _objectWithoutProperties2.default)(otherProps, _excluded2);
  var _useState = (0, _react.useState)(3),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    thumbnailSize = _useState2[0],
    setThumbnailSize = _useState2[1];
  var refImage = (0, _react.useCallback)(function (node) {
    if (node !== null && node !== void 0 && node.parentElement) {
      setThumbnailSize(node.parentElement.offsetWidth);
    }
  }, []);
  if (type === 'video') {
    var _videoTitle$0$duratio;
    var image;
    if (!disableImage) {
      var _cardProps$media;
      // use image src if passed in through props, otherwise use Kaltura's generated thumbnail image
      image = cardProps.image ? cardProps.image : {
        defaultSrc: _KalturaPlayer.default.getThumbnailUrl({
          mediaId: (_cardProps$media = cardProps.media) === null || _cardProps$media === void 0 ? void 0 : _cardProps$media.src,
          width: thumbnailSize
        }),
        alt: videoTitle[0].title
      };
      image = _objectSpread(_objectSpread({}, image), {}, {
        icon: PlayIcon,
        refImage: refImage
      });
    }
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, _CTALogic.default.launchLightBox(renderLightBox, openLightBox, otherProps.media), !renderLightBox && /*#__PURE__*/_react.default.createElement(_CardLink.CardLink, {
      customClassName: "".concat(prefix, "--card__CardCTA ").concat(prefix, "--card__video"),
      card: _objectSpread(_objectSpread({}, cardProps), {}, {
        cta: {
          href: '#',
          icon: {
            src: _CTALogic.default.iconSelector(type)
          },
          iconPlacement: 'left',
          copy: (_videoTitle$0$duratio = videoTitle[0].duration) === null || _videoTitle$0$duratio === void 0 ? void 0 : _videoTitle$0$duratio.replace(/\(|\)/g, ''),
          handleClick: function handleClick(e) {
            return _CTALogic.default.setLightBox(e, openLightBox);
          }
        },
        image: image,
        heading: videoTitle[0].title
      })
    }));
  } else {
    return /*#__PURE__*/_react.default.createElement(_CardLink.CardLink, {
      customClassName: "".concat(prefix, "--card__CardCTA"),
      card: _objectSpread(_objectSpread({}, cardProps), {}, {
        cta: {
          type: type,
          href: otherProps.cta.href,
          icon: {
            src: _CTALogic.default.iconSelector(type)
          }
        },
        copy: otherProps.copy,
        target: _CTALogic.default.external(type),
        href: otherProps.cta.href
      })
    });
  }
};
CardCTA.propTypes = {
  /**
   * CTA type. Choose from:
   *
   * | Type       | SVG element Name | Description                                                      |
   * | ---------- | ---------------- | ---------------------------------------------------------------- |
   * | `local`    | ArrowRight20     | Describes right arrow onClick which loads in self page.          |
   * | `jump`     | ArrowDown20      | Describes down arrow onClick which scrollToView of target.       |
   * | `external` | Launch20         | Describes launch arrow onClick which loads in new tab.           |
   * | `download` | Download20       | Describes download arrow onClick for downloading files.          |
   * | `video`    | PlayOutline20    | Describes play icon onClick which loads the video in a lightbox. |
   * | `default`  | None             | Describes the default CTA - without icon                         |
   *
   * For more details of icons, refer to:
   *
   * - [Icons library](https://www.carbondesignsystem.com/guidelines/icons/library/)!👀
   * - [@carbon/icons-react](https://github.com/carbon-design-system/carbon/tree/v1/packages/icons-react)!👀
   * - [carbon-icons](https://www.npmjs.com/package/carbon-icons)!👀
   */
  type: _propTypes.default.oneOfType([_propTypes.default.oneOf(['jump', 'local', 'external', 'download', 'video', 'default']), _propTypes.default.arrayOf(_propTypes.default.oneOf(['jump', 'local', 'external', 'download', 'video', 'default']))]),
  /**
   * Boolean to determine whether to disable image for card
   */
  disableImage: _propTypes.default.bool,
  /**
   * Func to set renderLightBox state.
   */
  openLightBox: _propTypes.default.func,
  /**
   * Bool to determine whether to open lightbox.
   */
  renderLightBox: _propTypes.default.bool,
  /**
   * Array of video titles.
   */
  videoTitle: _propTypes.default.arrayOf(_propTypes.default.shape({
    title: _propTypes.default.string,
    duration: _propTypes.default.string,
    key: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string])
  }))
};
CardCTA.defaultProps = {
  type: 'default',
  copy: '',
  cta: null,
  disableImage: false,
  media: null
};
var _default = exports.default = CardCTA;