"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _Button = _interopRequireDefault(require("../../internal/vendor/carbon-components-react/components/Button/Button"));
var _settings = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings"));
var _ = _interopRequireDefault(require("@carbon/icons-react/lib/earth--filled/20"));
var _LocaleModal = _interopRequireDefault(require("../LocaleModal/LocaleModal"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _settings2 = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
/**
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

var stablePrefix = _settings.default.stablePrefix;
var prefix = _settings2.default.prefix;

/**
 * Renders the locale button.
 */
var LocaleButton = function LocaleButton(_ref) {
  var displayLang = _ref.displayLang,
    aria = _ref.aria;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var localeButton = (0, _react.useRef)();
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--locale-btn__container")
  }, /*#__PURE__*/_react.default.createElement(_Button.default, {
    "data-autoid": "".concat(stablePrefix, "--locale-btn"),
    className: "".concat(prefix, "--locale-btn"),
    kind: "tertiary",
    ref: localeButton,
    onClick: open,
    renderIcon: _.default,
    iconDescription: "Earth Filled Icon",
    "aria-label": aria
  }, displayLang), /*#__PURE__*/_react.default.createElement(_LocaleModal.default, {
    isOpen: isOpen,
    setIsOpen: setIsOpen,
    closeFunc: function closeFunc() {
      setTimeout(function () {
        localeButton.current.focus();
      });
    }
  }));

  /**
   * Sets modal state to open
   *
   * @private
   */
  function open() {
    setIsOpen(true);
  }
};
LocaleButton.propTypes = {
  /**
   * Display language for locale button.
   */
  displayLang: _propTypes.default.string,
  /**
   * `aria-label`` value.
   */
  aria: _propTypes.default.string
};
var _default = exports.default = LocaleButton;