"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _ConditionalWrapper = _interopRequireDefault(require("../../internal/components/ConditionalWrapper/ConditionalWrapper"));
var _classnames = _interopRequireDefault(require("classnames"));
var _MastheadLogo = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-services/services/MastheadLogo/MastheadLogo"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _settings = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
var _TooltipDefinition = _interopRequireDefault(require("../../internal/vendor/carbon-components-react/components/TooltipDefinition"));
/**
 * Copyright IBM Corp. 2016, 2023
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var MastheadLogo = function MastheadLogo(props) {
  return /*#__PURE__*/_react.default.createElement("svg", props, /*#__PURE__*/_react.default.createElement("path", {
    d: "M58 21.467V23h-7.632v-1.533H58zm-18.316 0V23h-7.631v-1.533h7.631zm5.955 0L45.025 23l-.606-1.533h1.22zm-17.097 0A6.285 6.285 0 0 1 24.391 23H12.21v-1.533zm-17.858 0V23H0v-1.533h10.684zm29-3.067v1.533h-7.631V18.4h7.631zm7.148 0l-.594 1.533H43.82l-.598-1.533h3.609zm-16.764 0a5.719 5.719 0 0 1-.64 1.533H12.21V18.4zm-19.384 0v1.533H0V18.4h10.684zM58 18.4v1.533h-7.632V18.4H58zm-3.053-3.067v1.534h-4.579v-1.534h4.58zm-15.263 0v1.534h-4.579v-1.534h4.58zm8.345 0l-.6 1.534h-4.806l-.604-1.534h6.01zm-18.174 0c.137.49.213 1.003.213 1.534h-5.647v-1.534zm-10.013 0v1.534h-4.579v-1.534h4.58zm-12.21 0v1.534h-4.58v-1.534h4.58zm47.315-3.066V13.8h-4.579v-1.533h4.58zm-15.263 0V13.8h-4.579v-1.533h4.58zm9.541 0l-.597 1.533h-7.22l-.591-1.533h8.408zm-21.248 0c.527.432.98.951 1.328 1.533H15.263v-1.533zm-20.345 0V13.8h-4.58v-1.533h4.58zM44.599 9.2l.427 1.24.428-1.24h9.493v1.533h-4.579V9.324l-.519 1.41h-9.661l-.504-1.41v1.41h-4.579V9.2H44.6zm-36.967 0v1.533h-4.58V9.2h4.58zm21.673 0a5.95 5.95 0 0 1-1.328 1.533H15.263V9.2zm25.642-3.067v1.534h-8.964l.54-1.534h8.424zm-11.413 0l.54 1.534h-8.969V6.133h8.43zm-13.466 0c0 .531-.076 1.045-.213 1.534H24.42V6.133zm-10.226 0v1.534h-4.579V6.133h4.58zm-12.21 0v1.534h-4.58V6.133h4.58zm34.845-3.066l.53 1.533H32.054V3.067h10.424zm15.523 0V4.6H47.04l.55-1.533H58zm-28.573 0c.284.473.504.988.641 1.533H12.211V3.067zm-18.743 0V4.6H0V3.067h10.684zM41.406 0l.54 1.533h-9.893V0h9.353zM58 0v1.533h-9.881L48.647 0H58zM24.39 0c1.601 0 3.057.581 4.152 1.533H12.211V0zM10.685 0v1.533H0V0h10.684z",
    fill: "none",
    fillRule: "evenodd"
  }));
};
MastheadLogo.defaultProps = {
  width: "58",
  height: "23",
  viewBox: "0 0 58 23",
  xmlns: "http://www.w3.org/2000/svg"
};
var prefix = _settings.default.prefix;

/**
 * IBM Logo 8-bar component.
 */
var IbmLogo = function IbmLogo(_ref) {
  var autoid = _ref.autoid,
    logoData = _ref.logoData,
    isSearchActive = _ref.isSearchActive;
  var useAlternateLogo = _MastheadLogo.default.setMastheadLogo(logoData);
  var logoClasses = (0, _classnames.default)((0, _defineProperty2.default)((0, _defineProperty2.default)({}, "".concat(prefix, "--header__logo"), true), "".concat(prefix, "--search-active"), isSearchActive));
  return /*#__PURE__*/_react.default.createElement("div", {
    className: logoClasses
  }, /*#__PURE__*/_react.default.createElement(_ConditionalWrapper.default, {
    condition: logoData && logoData.tooltip !== undefined,
    wrapper: function wrapper(children) {
      return /*#__PURE__*/_react.default.createElement(_TooltipDefinition.default, {
        tooltipText: logoData.tooltip
      }, children);
    }
  }, useAlternateLogo ? /*#__PURE__*/_react.default.createElement("a", {
    // eslint-disable-line
    "aria-label": "IBM\xAE",
    "data-autoid": autoid,
    href: "https://www.ibm.com".concat(logoData.path),
    dangerouslySetInnerHTML: {
      __html: logoData.svg
    }
  }) : /*#__PURE__*/_react.default.createElement("a", {
    "aria-label": "IBM\xAE",
    "data-autoid": autoid,
    href: "https://www.ibm.com"
  }, !useAlternateLogo && /*#__PURE__*/_react.default.createElement(MastheadLogo, null))));
};
var _default = exports.default = IbmLogo;
IbmLogo.propTypes = {
  /**
   * data-autoid attribute for analytics
   */
  autoid: _propTypes.default.string,
  /**
   * `true` when search is active
   */
  isSearchActive: _propTypes.default.bool,
  /**
   * Masthead logo object
   * See [mastheadLogo](#mastheadlogo)
   * for details.
   */
  logoData: _propTypes.default.shape({
    svg: _propTypes.default.string,
    tooltip: _propTypes.default.string,
    denyList: _propTypes.default.array,
    allowList: _propTypes.default.array,
    expire: _propTypes.default.string,
    path: _propTypes.default.string
  })
};