"use strict";

/**
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * URLs for Masthead L0
 *
 * type {{}}
 */

var mastheadLinks = [{
  title: 'Lorem ipsum dolor sit amet',
  titleEnglish: 'Lorem ipsum dolor sit amet',
  url: '',
  hasMenu: true,
  hasMegapanel: false,
  menuSections: [{
    heading: 'Explore',
    menuItems: [{
      title: 'Link 1',
      url: '',
      megapanelContent: {
        headingTitle: '',
        headingUrl: '',
        description: '',
        quickLinks: {
          title: 'Title',
          links: [{
            title: 'Subnav 1',
            url: ''
          }, {
            title: 'Subnav 2',
            url: ''
          }, {
            title: 'Subnav 3',
            url: ''
          }, {
            title: 'Subnav 4',
            url: ''
          }]
        },
        feature: {
          heading: '',
          imageUrl: '',
          linkTitle: '',
          linkUrl: ''
        }
      }
    }, {
      title: 'Menu dropdown item with extra long text',
      url: ''
    }]
  }]
}, {
  title: 'Consectetur adipiscing elit',
  titleEnglish: 'Consectetur adipiscing elit',
  url: '',
  hasMenu: true,
  menuSections: [{
    heading: '',
    menuItems: [{
      title: 'Link 2',
      url: '',
      megapanelContent: {
        headingTitle: 'Services',
        headingUrl: 'https://www.ibm.com/services?lnk=hpmse_ts&lnk2=learn',
        description: 'Reimagine your business, designing and building the platforms necessary for growth',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Subnav 1',
            url: ''
          }, {
            title: 'Subnav 2',
            url: ''
          }, {
            title: 'Subnav 3',
            url: ''
          }, {
            title: 'Subnav 4',
            url: ''
          }]
        },
        feature: {
          heading: 'IBM Services, your Digital Reinvention â„¢ partner',
          imageUrl: 'https://www.ibm.com/images/portal/U609055Q90660U49/windmills.jpg',
          linkTitle: 'Explore all our business consulting and technology services',
          linkUrl: 'https://www.ibm.com/services?lnk=hpmse_ts&lnk2=learn'
        }
      }
    }, {
      title: 'Financing',
      url: 'https://www.ibm.com/financing?lnk=hpmse_fin&lnk2=learn',
      megapanelContent: {
        headingTitle: 'Financing',
        headingUrl: 'https://www.ibm.com/financing?lnk=hpmse_fin&lnk2=learn',
        description: 'Funding options that fit your business',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Subnav 1',
            url: ''
          }, {
            title: 'Subnav 2',
            url: ''
          }, {
            title: 'Subnav 3',
            url: ''
          }, {
            title: 'Subnav 4',
            url: ''
          }]
        },
        feature: {
          heading: 'Cloud financing strategies that work for your business',
          imageUrl: 'https://www.ibm.com/images/portal/F774737R30303N19/Skyline-Card-cloud-feature380x160.jpg?1=1',
          linkTitle: 'Committed to cloud? Make the most of your cash flow.',
          linkUrl: 'https://www.ibm.com/financing/solutions/cloud-financing?lnk=hpmse_fin&lnk2=learn'
        }
      }
    }]
  }]
}, {
  title: 'Nulla quis sem at nibh elementum imperdiet',
  titleEnglish: 'Nulla quis sem at nibh elementum imperdiet',
  url: 'https://www.ibm.com/industries?lnk=min',
  hasMenu: false,
  hasMegapanel: false,
  menuSections: []
}, {
  title: 'Fusce nec tellus sed augue semper porta',
  titleEnglish: 'Fusce nec tellus sed augue semper porta',
  url: '',
  hasMenu: true,
  hasMegapanel: false,
  menuSections: [{
    heading: '',
    menuItems: [{
      title: 'IBM Developer',
      url: 'https://developer.ibm.com/?lnk=hpmdev_dw&lnk2=learn',
      megapanelContent: {
        headingTitle: 'IBM Developer',
        headingUrl: 'https://developer.ibm.com/?lnk=hpmdev_dw&lnk2=learn',
        description: '',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Subnav 1',
            url: ''
          }, {
            title: 'Subnav 2',
            url: ''
          }, {
            title: 'Subnav 3',
            url: ''
          }, {
            title: 'Subnav 4',
            url: ''
          }]
        },
        feature: {
          heading: 'IBM Developer newsletters',
          imageUrl: 'https://1.dam.s81c.com/m/5908c17b26b9dd19/original/news-ibmdevnewsletters-600x245.jpg',
          linkTitle: 'Technical info on popular software development topics, including AI, Blockchain, Java and more',
          linkUrl: 'https://developer.ibm.com/newsletters/?lnk=hpmdev_dw&lnk2=learn'
        }
      }
    }, {
      title: 'Blockchain',
      url: 'https://developer.ibm.com/technologies/blockchain/?lnk=hpmdev_dw&lnk2=learn',
      megapanelContent: {
        headingTitle: 'Blockchain',
        headingUrl: 'https://developer.ibm.com/technologies/blockchain/?lnk=hpmdev_dw&lnk2=learn',
        description: '',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Subnav 1',
            url: ''
          }, {
            title: 'Subnav 2',
            url: ''
          }, {
            title: 'Subnav 3',
            url: ''
          }, {
            title: 'Subnav 4',
            url: ''
          }]
        },
        feature: {
          heading: 'Blockchain 101',
          imageUrl: 'https://www.ibm.com/images/portal/E174255N41814O86/Blockchain2_600x245.jpg?1=3',
          linkTitle: 'Build a kick-starter blockchain network and start coding with the IBM Blockchain Platform Starter Plan',
          linkUrl: 'https://developer.ibm.com/tutorials/cl-ibm-blockchain-101-quick-start-guide-for-developers-bluemix-trs/?lnk=hpmdev_dw&lnk2=learn'
        }
      }
    }, {
      title: 'Containers',
      url: 'https://developer.ibm.com/technologies/containers/?lnk=hpmdev_dw&lnk2=learn',
      megapanelContent: {
        headingTitle: 'Containers',
        headingUrl: 'https://developer.ibm.com/technologies/containers/?lnk=hpmdev_dw&lnk2=learn',
        description: '',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Code patterns',
            url: 'https://developer.ibm.com/patterns/category/containers/?lnk=hpmdev_dw&lnk2=learn'
          }, {
            title: 'Tutorials',
            url: 'https://developer.ibm.com/tutorials/category/containers/?lnk=hpmdev_dw&lnk2=learn'
          }, {
            title: 'Events',
            url: 'https://developer.ibm.com/events/category/containers/?lnk=hpmdev_dw&lnk2=learn'
          }]
        },
        feature: {
          heading: 'Make sense of Kubernetes',
          imageUrl: 'https://www.ibm.com/images/portal/E693054G76296P64/Kubernetes-Pythomn_600x245.jpg?1=2',
          linkTitle: 'Deploy a simple Python application with Kubernetes',
          linkUrl: 'https://developer.ibm.com/tutorials/scalable-python-app-with-kubernetes/?lnk=hpmdev_dw&lnk2=learn'
        }
      }
    }, {
      title: 'Analytics',
      url: 'https://developer.ibm.com/technologies/analytics/?lnk=hpmdev_dw&lnk2=learn',
      megapanelContent: {
        headingTitle: 'Analytics',
        headingUrl: 'https://developer.ibm.com/technologies/analytics/?lnk=hpmdev_dw&lnk2=learn',
        description: '',
        quickLinks: {
          title: 'Quicklinks',
          links: [{
            title: 'Code patterns',
            url: 'https://developer.ibm.com/patterns/category/analytics/?lnk=hpmdev_dw&lnk2=learn'
          }, {
            title: 'Tutorials',
            url: 'https://developer.ibm.com/tutorials/category/analytics/?lnk=hpmdev_dw&lnk2=learn'
          }, {
            title: 'Events',
            url: 'https://developer.ibm.com/events/category/analytics/?lnk=hpmdev_dw&lnk2=learn'
          }, {
            title: 'Developer community',
            url: 'https://developer.ibm.com/watson/?lnk=hpmdev_dw&lnk2=learn'
          }]
        },
        feature: {
          heading: 'Train your data no matter where it lives',
          imageUrl: 'https://1.dam.s81c.com/m/76c0ed6f3e6386c1/original/Train-data_600x245.jpg',
          linkTitle: 'Easily and securely connect to your data source for initial model training and continuous learning',
          linkUrl: 'https://developer.ibm.com/announcements/training-machine-learning-models-in-watson-studio?lnk=hpmdev_dw&lnk2=learn'
        }
      }
    }]
  }]
}, {
  title: 'Sed cursus ante dapibus diam',
  titleEnglish: 'Sed cursus ante dapibus diam',
  url: 'https://www.ibm.com/support/home/?lnk=msu_usen',
  hasMenu: false,
  hasMegapanel: false,
  menuSections: []
}];
module.exports = mastheadLinks;