"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMappedValue = void 0;
var _ccLcMap = _interopRequireDefault(require("./cc-lc-map"));
/**
 * Copyright IBM Corp. 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

var getMappedValue = exports.getMappedValue = function getMappedValue(locale) {
  var CcLcValue = {
    cc: 'us',
    lc: 'en'
  };
  if (Object.prototype.isPrototypeOf.call(_ccLcMap.default, locale)) {
    CcLcValue = _ccLcMap.default[locale];
  } else if (locale.indexOf('-') > -1) {
    var splitValue = locale.split('-', 2);
    CcLcValue = {
      cc: splitValue[0],
      lc: splitValue[1]
    };
  }
  return CcLcValue;
};