"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classnames = _interopRequireDefault(require("classnames"));
var _ContentItem = _interopRequireDefault(require("../ContentItem/ContentItem"));
var _settings = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _settings2 = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
var _excluded = ["src"];
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2.default)(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var stablePrefix = _settings.default.stablePrefix;
var prefix = _settings2.default.prefix;

/**
 * Content with pictogram component.
 */
var PictogramItem = function PictogramItem(_ref) {
  var heading = _ref.heading,
    copy = _ref.copy,
    _ref$pictogram = _ref.pictogram,
    Pictogram = _ref$pictogram.src,
    pictogramProps = (0, _objectWithoutProperties2.default)(_ref$pictogram, _excluded),
    cta = _ref.cta,
    className = _ref.className;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)(className, "".concat(prefix, "--pictogram-item")),
    "data-autoid": "".concat(stablePrefix, "--pictogram-item")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--pictogram-item__row")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--pictogram-item__wrapper")
  }, /*#__PURE__*/_react.default.createElement(Pictogram, (0, _extends2.default)({
    "data-autoid": "".concat(stablePrefix, "--pictogram-item__pictogram"),
    className: "".concat(prefix, "--pictogram-item__pictogram")
  }, pictogramProps))), /*#__PURE__*/_react.default.createElement("div", {
    "data-autoid": "".concat(stablePrefix, "--pictogram-item__content"),
    className: "".concat(prefix, "--pictogram-item__content")
  }, /*#__PURE__*/_react.default.createElement(_ContentItem.default, {
    heading: heading,
    copy: copy,
    cta: cta && _objectSpread({
      style: 'text'
    }, cta)
  }))));
};
PictogramItem.propTypes = {
  /**
   * Content with pictogram component title property.
   */
  heading: _propTypes.default.string.isRequired,
  /**
   * Content with pictogram component copy property.
   */
  copy: _propTypes.default.string.isRequired,
  /**
   * Object with CTA data.
   * See the [`<CTA>`'s README](http://www.ibm.com/standards/carbon/react/?path=/docs/components-cta--default#props) for full usage details.
   */
  cta: _propTypes.default.shape({
    type: _propTypes.default.oneOfType([_propTypes.default.oneOf(['jump', 'local', 'external', 'download', 'video']), _propTypes.default.arrayOf(_propTypes.default.oneOf(['jump', 'local', 'external', 'download', 'video']))]),
    copy: _propTypes.default.string,
    href: _propTypes.default.string,
    customClassName: _propTypes.default.string
  }),
  /**
   * Pictogram data object.
   * The structure is:
   *
   * | Name  | Required | Data Type | Default Value | Description                                                  |
   * | ----- | -------- | --------- | ------------- | ------------------------------------------------------------ |
   * | `src` | YES      | Component | null          | Pictogram component imported from `@carbon/pictograms-react` |
   */
  pictogram: _propTypes.default.shape({
    src: _propTypes.default.object.isRequired
  }).isRequired,
  /**
   * Pictogram Item `className`` prop.
   */
  className: _propTypes.default.string
};
var _default = exports.default = PictogramItem;