"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _ = _interopRequireDefault(require("@carbon/icons-react/lib/arrow--right/20"));
var _2 = _interopRequireDefault(require("@carbon/icons-react/lib/chevron--left/20"));
var _settings = _interopRequireDefault(require("../../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/settings/settings"));
var _settings2 = _interopRequireDefault(require("carbon-components/umd/globals/js/settings"));
var _SideNavLink = _interopRequireDefault(require("../../../internal/vendor/carbon-components-react/components/UIShell/SideNavLink"));
var _SideNavMenu = _interopRequireDefault(require("./SideNavMenu"));
var _SideNavMenuItem = _interopRequireDefault(require("../../../internal/vendor/carbon-components-react/components/UIShell/SideNavMenuItem"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireWildcard(require("react"));
var _excluded = ["title", "titleUrl", "backButtonText", "children"];
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
/**
 * Copyright IBM Corp. 2016, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var stablePrefix = _settings.default.stablePrefix;
var prefix = _settings2.default.prefix;

/**
 * Side nav menu with back button
 *
 * @returns {*} SideNavMenuWithBackFoward menu items
 */
var SideNavMenuWithBackForward = function SideNavMenuWithBackForward(_ref) {
  var title = _ref.title,
    titleUrl = _ref.titleUrl,
    backButtonText = _ref.backButtonText,
    children = _ref.children,
    rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var refSideNavMenu = (0, _react.useRef)(null);
  var handleToggle = (0, _react.useCallback)(function () {
    var sideNavMenuNode = refSideNavMenu.current;
    var sideNav = sideNavMenuNode.closest('.bx--side-nav');
    if (sideNav) {
      Array.prototype.forEach.call(sideNav.querySelectorAll('.bx--side-nav__menu'), function (elem) {
        var hasExpandedSubmenu = elem.querySelector('.bx--side-nav__submenu[aria-expanded="true"]');
        elem.classList.toggle('bx--side-nav__menu--hasactivechildren', hasExpandedSubmenu);
      });
    }

    // return scroll to top when menu toggles
    var sideNavItems = sideNavMenuNode.closest('.bx--side-nav__items');
    sideNavItems.scrollTop = 0;
  }, []);
  return /*#__PURE__*/_react.default.createElement(_SideNavMenu.default, {
    autoid: rest.autoid,
    selected: rest.selected,
    title: title,
    className: rest.lastHighlighted && "".concat(prefix, "--masthead__side-nav__last-highlighted"),
    onToggle: handleToggle,
    ref: refSideNavMenu,
    dataTitle: rest.dataTitle
  }, /*#__PURE__*/_react.default.createElement(_SideNavMenuItem.default, {
    onClick: function onClick(event) {
      return event.preventDefault();
    },
    className: "".concat(prefix, "--masthead__side-nav--submemu-back"),
    "data-autoid": "".concat(stablePrefix, "--masthead-").concat(rest.navType, "-sidenav__l0-back"),
    isbackbutton: "true",
    role: "button",
    tabIndex: "0"
  }, /*#__PURE__*/_react.default.createElement(_2.default, null), backButtonText), titleUrl ? /*#__PURE__*/_react.default.createElement(_SideNavLink.default, {
    className: "".concat(prefix, "--masthead__side-nav--submemu-section-title"),
    href: titleUrl
  }, title, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "--masthead__side-nav--submemu-section-title__icon")
  }, /*#__PURE__*/_react.default.createElement(_.default, null))) : /*#__PURE__*/_react.default.createElement("li", {
    className: "".concat(prefix, "--masthead__side-nav--submemu-title")
  }, title), rest.heading && /*#__PURE__*/_react.default.createElement("p", {
    className: "".concat(prefix, "--masthead__side-nav--submemu-heading")
  }, rest.heading), children);
};
SideNavMenuWithBackForward.propTypes = {
  /**
   * Submenu nav section title
   */
  title: _propTypes.default.string.isRequired,
  /**
   * Submenu nav section title url
   */
  titleUrl: _propTypes.default.string,
  /**
   * Back button text
   */
  backButtonText: _propTypes.default.string,
  /**
   * Sidenav child elements to be rendered
   */
  children: _propTypes.default.oneOfType([_propTypes.default.arrayOf(_propTypes.default.node), _propTypes.default.node])
};
var _default = exports.default = SideNavMenuWithBackForward;