"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _axios = _interopRequireDefault(require("axios"));
var _jsCookie = _interopRequireDefault(require("js-cookie"));
/**
 * Copyright IBM Corp. 2021, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * The cookie name for determining user login status for cloud.ibm.com.
 *
 * @type {string}
 * @private
 */
var _cookieName = 'com.ibm.cloud.iam.LoggedIn.prod';
var CloudAccountAuthAPI = /*#__PURE__*/function () {
  function CloudAccountAuthAPI() {
    (0, _classCallCheck2.default)(this, CloudAccountAuthAPI);
  }
  (0, _createClass2.default)(CloudAccountAuthAPI, null, [{
    key: "checkCookie",
    value:
    /**
     * retrieve the cloud login status via cookie
     *
     * @example
     * import { cloudAccountAuthentication } from '@carbon/ibmdotcom-utilities';
     *
     * const status = cloudAccountAuthentication.checkCookie();
     * @returns {string} string determining login status
     */
    function checkCookie() {
      var cloudLogin = _jsCookie.default.get(_cookieName);
      return {
        user: cloudLogin === '1' ? 'authenticated' : 'anonymous'
      };
    }

    /**
     * retrieve the cloud login status via api
     *
     * @example
     * import { cloudAccountAuthentication } from '@carbon/ibmdotcom-utilities';
     *
     * const status = cloudAccountAuthentication.checkAPI();
     * @returns {string} string determining login status
     */
  }, {
    key: "checkAPI",
    value: function () {
      var _checkAPI = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        var cloudLogin;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _axios.default.get('/api/v6/selected-account?profile=true', {
                headers: {
                  Accept: 'application/json'
                }
              }).then(function (response) {
                return response.status === 200 ? 'authenticated' : 'anonymous';
              }).catch(function (error) {
                console.error(error);
                return 'anonymous';
              });
            case 2:
              cloudLogin = _context.sent;
              return _context.abrupt("return", {
                user: cloudLogin
              });
            case 4:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function checkAPI() {
        return _checkAPI.apply(this, arguments);
      }
      return checkAPI;
    }()
  }]);
  return CloudAccountAuthAPI;
}();
var _default = exports.default = CloudAccountAuthAPI;