"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.globalInit = globalInit;
var _Analytics = require("../Analytics");
var _DDO = require("../DDO");
var _loadNonLatinPlex = _interopRequireDefault(require("../../internal/vendor/@carbon/ibmdotcom-utilities/utilities/loadNonLatinPlex/loadNonLatinPlex"));
var _Locale = require("../Locale");
/**
 * Copyright IBM Corp. 2020, 2022
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Flag to determine if the global init has been fired
 *
 * @type {boolean}
 * @private
 */
var _initialized = false;

/**
 * Initializes various global functions
 */
function globalInit() {
  if (_initialized) {
    return;
  } else {
    _initialized = true;
  }

  // Sets the version of the library in the DDO
  _DDO.DDOAPI.setVersion().catch(function (error) {
    console.error('Error setting the version of the library in the DDO:', error);
  });

  // Sets the Plex font for non-Latin fonts
  _Locale.LocaleAPI.getLang().then(function (lang) {
    (0, _loadNonLatinPlex.default)(lang.lc);
  });

  // analytics tracking
  _Analytics.AnalyticsAPI.initAll();
}